<?php
/* HEADER */ if ($TWIST_FILE_INFO) {echo __FILE__.': $Id: GDAL_OGR.inc,v 1.1 2004/05/19 16:48:33 jiva Exp $'.'$Name:  $';exit;}; /* HEADER */

require_once(FileUp2(".admin/main_editlayer.inc"));

class GDAL_OGR_EditLayer extends EditLayer {

  function GDAL_OGR_EditLayer($vobj) {
    $this->EditLayer($vobj);
    
  }

  function Insert($shape, $attrib) {
    $gml = $this->CreateGML($shape, $attrib);
    print_r($gml);
    return ($this->ret?true:false);
  }
  
  function Metadata() {
    if ($this->vobj->layer_properties['dataset']['metadata'])
      return $this->vobj->layer_properties['dataset']['metadata'];
    else 
    return array();
  }

  function CreateGML($shape, $attrib) {
    $xsd  = '<?xml version="1.0" encoding="UTF-8"?>'."\n";
    $xsd .= '<xs:schema targetNamespace="http://gdal.velocet.ca/ogr" xmlns:ogr="http://gdal.velocet.ca/ogr" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:gml="http://www.opengis.net/gml" elementFormDefault="qualified" version="1.0">'."\n";
    $xsd .= '  <xs:import namespace="http://www.opengis.net/gml" schemaLocation="http://schemas.cubewerx.com/schemas/gml/2.1.2/feature.xsd"/>'."\n";
    $xsd .= '  <xs:element name="FeatureCollection" type="ogr:FeatureCollectionType" substitutionGroup="gml:_FeatureCollection"/>'."\n";
    $xsd .= '  <xs:complexType name="FeatureCollectionType">'."\n";
    $xsd .= '    <xs:complexContent>'."\n";
    $xsd .= '      <xs:extension base="gml:AbstractFeatureCollectionType">'."\n";
    $xsd .= '        <xs:attribute name="lockId" type="xs:string" use="optional"/>'."\n";
    $xsd .= '        <xs:attribute name="scope" type="xs:string" use="optional"/>'."\n";
    $xsd .= '      </xs:extension>'."\n";
    $xsd .= '    </xs:complexContent>'."\n";
    $xsd .= '  </xs:complexType>'."\n";
    $xsd .= '  <xs:element name="editvector" type="ogr:editvector_Type" substitutionGroup="gml:_Feature"/>'."\n";
    $xsd .= '  <xs:complexType name="editvector_Type">'."\n";
    $xsd .= '    <xs:complexContent>'."\n";
    $xsd .= '      <xs:extension base="gml:AbstractFeatureType">'."\n";
    $xsd .= '        <xs:sequence>'."\n";
    $xsd .= '          <xs:element name="geometryProperty" type="gml:geometryPropertyType" nillable="true" minOccurs="1" maxOccurs="1"/>'."\n";
/*    $xsd .= '          <xs:element name="ID" nillable="true" minOccurs="0" maxOccurs="1">'."\n";
    $xsd .= '            <xs:simpleType>'."\n";
    $xsd .= '              <xs:restriction base="xs:integer">'."\n";
    $xsd .= '                <xs:totalDigits value="8"/>'."\n";
    $xsd .= '              </xs:restriction>'."\n";
    $xsd .= '            </xs:simpleType>'."\n";
    $xsd .= '          </xs:element>'."\n";*/
    
    $met = $this->Metadata();
    foreach($met as $key=>$val) {
    $xsd .= '          <xs:element name="'.$val['name'].'" nillable="'.($val['null']?'true':'false').'" minOccurs="0" maxOccurs="1">'."\n";
    $xsd .= '            <xs:simpleType>'."\n";
    $xsd .= '              <xs:restriction base="xs:'.$val['type'].'">'."\n";

    if ($val['len']) {
    $xsd .= '                <xs:maxLength value="'.$val['len'].'"/>'."\n";
    }

    $xsd .= '              </xs:restriction>'."\n";
    $xsd .= '            </xs:simpleType>'."\n";
    $xsd .= '          </xs:element>'."\n";
    }
    
    $xsd .= '        </xs:sequence>'."\n";
    $xsd .= '      </xs:extension>'."\n";
    $xsd .= '    </xs:complexContent>'."\n";
    $xsd .= '  </xs:complexType>'."\n";
    $xsd .= '</xs:schema>'."\n";


    $gml  = '<?xml version="1.0" encoding="utf-8" ?>'."\n";
    $gml .= '<ogr:FeatureCollection xmlns:xsi="http://www.w3c.org/2001/XMLSchema-instance" xsi:schemaLocation=". a.xsd" xmlns:gml="http://www.opengis.net/gml">'."\n";
    
    return array('xsd'=>$xsd, 'gml'=>$gml);
  }
  
}

?>
